#include <GL\glut.h>
#include "Robot.h"
#include "..\HierarquicoCommon\Util.h"


#define TORSO_WIDTH			0.75
#define TORSO_HEIGHT		1.5
#define HEAD_WIDTH		0.3
#define HEAD_HEIGTH		0.5


Robot::Robot(void) //: selectedArm(left)
{
	selectedArm = &left;
}

Robot::~Robot(void)
{
}

void Robot::Display(GLenum mode, bool showAxis)
{
	GLfloat mat_1[] = {0.6, 0.6, 0.6, 1.0};
	GLfloat mat_2[] = {1, 1, 0, 1.0};
	GLfloat mat_3[] = {0, 1, 1, 1.0};
	GLfloat mat_4[] = {1, 1, 1, 1.0};
	GLfloat mat_5[] = {1, 0, 1, 1.0};

	glPushMatrix();
		// torso
		glRotatef(rotTorso, 0, 0, 1);
		if (showAxis)
			drawAxis(0.5);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mat_2);
		cylinderWithTopAndBottom(mode, TORSO_WIDTH, TORSO_HEIGHT, 6, 2);

		glPushMatrix();
			// kneck
			glTranslatef(0, 0, TORSO_HEIGHT);
			glRotatef(rotKneck, 0, 0, 1);
			if (showAxis)
				drawAxis(0.5);

			// head
			glRotatef(rotHead, 0, 1, 0);
			if (showAxis)
				drawAxis(0.5);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mat_2);
			box(mode, HEAD_WIDTH, HEAD_HEIGTH);
			// nose
			glTranslatef(HEAD_WIDTH/2, 0, 3*HEAD_HEIGTH/4);
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mat_3);
			box(mode, 0.01, 0.01);
		glPopMatrix();

		// left arm
		glPushMatrix();
			glTranslatef(-TORSO_WIDTH/2, 0, TORSO_HEIGHT);
			glRotatef(-90, 0, 1, 0);
			left.Display(mode, showAxis);
		glPopMatrix();
		
		// rigth arm
		glPushMatrix();
			glTranslatef(+TORSO_WIDTH/2, 0, TORSO_HEIGHT);
			glRotatef(+90, 0, 1, 0);
			right.Display(mode, showAxis);
		glPopMatrix();

	glPopMatrix();
}
