#pragma once

#include <GL\glut.h>
#include "..\HierarquicoCommon\RobotArm.h"

class Robot
{
	GLfloat rotTorso;
	GLfloat rotKneck;
	GLfloat rotHead;

	RobotArm left, right;
	RobotArm* selectedArm;

public:
	Robot(void);
public:
	~Robot(void);

	void Display(GLenum mode, bool showAxis);

	void IncRotTorso(GLfloat delta)	{ rotTorso += delta; if (rotTorso > 360.0) rotTorso = 0; }
	void DecRotTorso(GLfloat delta)	{ rotTorso -= delta; if (rotTorso < 0) rotTorso = 360; }
	void IncRotKneck(GLfloat delta)	{ rotKneck += delta; if (rotKneck > 90.0) rotKneck = 90; }
	void DecRotKneck(GLfloat delta)	{ rotKneck -= delta; if (rotKneck < -90) rotKneck = -90; }
	void IncRotHead(GLfloat delta)	{ rotHead += delta; if (rotHead > 60.0) rotHead = 60; }
	void DecRotHead(GLfloat delta)	{ rotHead -= delta; if (rotHead < -60) rotHead = -60; }

	enum ArmEnum {Left, Right};
	void SelectArm(ArmEnum a)	{ a == Left ? selectedArm = &left : selectedArm = &right; }
	RobotArm* SelectedArm()		{ return selectedArm; }
};
