#include <GL\glut.h>
#include "Camara.h"

Camara::Camara(void)
{
}

PolarCamara::PolarCamara(GLfloat distance, GLfloat twist, GLfloat elevation, GLfloat azimuth)
{
	SetCamara(distance, twist, elevation, azimuth);
}

void PolarCamara::SetCamara(GLfloat distance, GLfloat twist, GLfloat elevation, GLfloat azimuth)
{
	this->distance = distance;
	this->twist = twist;
	this->elevation = elevation;
	this->azimuth = azimuth;
}

void PolarCamara::SetView()
{
	glTranslated(0.0, 0.0, -distance);
	glRotated(elevation, 1.0, 0.0, 0.0);
	glRotated(azimuth, 0.0, 1.0, 0.0);
	glRotated(twist, 0.0, 0.0, 1.0);
}

EyeCamara::EyeCamara(GLfloat x, GLfloat y, GLfloat z)
{
	SetCamara(x, y, z);
	SetCenter(0, 0, 0);
	SetUp(0, 1, 0);
}

void EyeCamara::SetCamara(GLfloat x, GLfloat y, GLfloat z)
{
	this->x = x;
	this->y = y;
	this->z = z;
}

void EyeCamara::SetCenter(GLfloat cx, GLfloat cy, GLfloat cz)
{
	this->cx = cx;
	this->cy = cy;
	this->cz = cz;
}

void EyeCamara::SetUp(GLfloat ux, GLfloat uy, GLfloat uz)
{
	this->ux = ux;
	this->uy = uy;
	this->uz = uz;
}

void EyeCamara::SetView()
{
	gluLookAt(x, y, z, cx, cy, cz, ux, uy, uz);
}
